config/routes.rb
require 'sidekiq/web'

Rails.application.routes.draw do
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

  mount Sidekiq::Web => '/sidekiq'
  devise_for :users

  authenticated :user do
    root to: 'store#index', as: :store_root
  end
  root to: 'visitors#index'

  resources :ovens do
    resource :cookies
    member do
      post :empty
    end
  end
end

app/models/cookie.rb
class Cookie < ActiveRecord::Base
  belongs_to :storage, polymorphic: :true
  
  validates :storage, presence: true

  def ready?
    is_cooked
  end
end

app/models/oven.rb
class Oven < ActiveRecord::Base
  belongs_to :user
  has_one :cookie, as: :storage

  validates :user, presence: true
end

app/models/user.rb
class User < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable

  has_many :ovens
  has_many :stored_cookies, class_name: 'Cookie', as: :storage

  before_create :setup_first_oven

  private

  def setup_first_oven
    ovens.new(name: 'My First Oven')
  end

end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception

  before_action :basic_authenticate

  private

  def basic_authenticate
    return if Rails.env.test?

    authenticate_or_request_with_http_basic do |username, password|
      username == 'bake' && password == 'somecookies'
    end

  end
end

app/controllers/cookies_controller.rb
class CookiesController < ApplicationController
  before_action :authenticate_user!

  def new
    @oven = current_user.ovens.find_by!(id: params[:oven_id])
    if @oven.cookie
      redirect_to @oven, alert: 'A cookie is already in the oven!'
    else
      @cookie = @oven.build_cookie
    end
  end

  def create
    @oven = current_user.ovens.find_by!(id: params[:oven_id])
    @cookie = @oven.create_cookie!(cookie_params)
    if @cookie.persisted?
      BakeCookiesJob.set(wait: 2.minutes).perform_later @cookie
    end
    redirect_to oven_path(@oven)
  end

  private

  def cookie_params
    params.require(:cookie).permit(:fillings, :quantity)
  end
end

app/controllers/ovens_controller.rb
class OvensController < ApplicationController
  before_action :authenticate_user!

  def index
    @ovens = current_user.ovens
  end

  def show
    @oven = current_user.ovens.find_by!(id: params[:id])
  end

  def empty
    @oven = current_user.ovens.find_by!(id: params[:id])
    if @oven.cookie
      @oven.cookie.update_attributes!(storage: current_user)
    end
    redirect_to @oven, alert: 'Oven emptied!'
  end
end

app/controllers/store_controller.rb
class StoreController < ApplicationController
  def index
    @cookies = Cookie.where(storage: current_user).group(:fillings).sum(:quantity)
    puts @cookies.inspect
  end
end

app/controllers/visitors_controller.rb
class VisitorsController < ApplicationController
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/cookies_helper.rb
module CookiesHelper
end

app/helpers/ovens_helper.rb
module OvensHelper
end

app/views/cookies/new.html.erb
<h3>New Cookie for oven <%= @oven.name %></h3>

<%= form_for [@oven, @cookie] do |f| %>
  <div class="row">
    <div class="small-8 columns">
      <%= f.label :fillings %>
    </div>
  </div>
  <div class="row">
    <div class="small-8 columns">
      <%= f.text_field :fillings %>
    </div>
  </div>
  <div class="row">
    <div class="small-8 columns">
      <%= f.label :quantity %>
    </div>
  </div>
  <div class="row">
    <div class="small-8 columns">
      <%= f.number_field :quantity, min: 1, max: 12 %>
    </div>
  </div>
  <div class="row">
    <div class="small-8 columns">
      <%= f.submit 'Mix and bake', class: 'button' %>
    </div>
  </div>
<% end %>

app/views/layouts/_messages.html.erb
<% # Rails flash messages styled for Zurb Foundation %>
<% flash.each do |name, msg| %>
  <% if msg.is_a?(String) %>
    <div class="alert-box round <%= name.to_s == 'notice' ? 'success' : 'alert' %>" data-alert="">
      <%= content_tag :div, msg %>
      <a href="#" class="close">&times;</a>
    </div>
  <% end %>
<% end %>

app/views/layouts/_navigation.html.erb
<div class="contain-to-grid">
  <nav class="top-bar" data-topbar="true">
    <ul class="title-area">
      <li class="name"><%= link_to 'Home', root_path %></li>
      <li class="toggle-topbar menu-icon"><a href="#">Menu</a></li>
    </ul>
    <div class="top-bar-section">
      <ul class="right"><%= render 'layouts/navigation_links' %></ul>
    </div>
  </nav>
</div>

app/views/layouts/_navigation_links.html.erb
<%# add navigation links to this file %>
<% if user_signed_in? %>
  <li><%= link_to "Ovens", ovens_path %></li>
  <li><%= link_to 'Edit account', edit_user_registration_path %></li>
  <li><%= link_to 'Sign out', destroy_user_session_path, :method=>'delete' %></li>
<% else %>
  <li><%= link_to 'Sign in', new_user_session_path %></li>
  <li><%= link_to 'Sign up', new_user_registration_path %></li>
<% end %>

app/views/layouts/application.html.erb
<html>
  <head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title><%= content_for?(:title) ? yield(:title) : 'Flowspace Bakery' %></title>
    <meta name="description" content="<%= content_for?(:description) ? yield(:description) : 'Flowspace Bakery' %>">
    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track' => true %>
    <%= javascript_include_tag 'vendor/modernizr' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
    <%= csrf_meta_tags %>
  </head>
  <body>
    <header>
      <%= render 'layouts/navigation' %>
    </header>
    <div class="row">
      <main role="main">
        <%= render 'layouts/messages' %>
        <%= yield %>
      </main>
    </div>
  </body>
</html>

app/views/ovens/index.html.erb
<h3>My Ovens</h3>
<ul class="ovens">
  <%  @ovens.each do |oven| %>
    <%= link_to oven.name, oven %>
  <% end %>
</ul>

app/views/ovens/show.html.erb
<h3><%= @oven.name %></h3>
<div class="cookie-info">
  <div class="mobile-only">
    <%= link_to "Prepare Cookie", new_oven_cookies_path(@oven), class: 'button' %>
  </div>
  Cookie in oven:
  <% if @oven.cookie %>
    <%= pluralize(@oven.cookie.quantity, "cookie") %> with <%= @oven.cookie.fillings || "no fillings" %>
    <% if @oven.cookie.ready? %>
      (Your Cookie is Ready)
      <%= button_to "Retrieve Cookie", empty_oven_path, class: 'button tiny' %>
    <% else %>
      (Your Cookie is Still Cooking)
    <% end %>
  <% else %>
    None
  <% end %>
</div>
<div class="desktop-only">
  <%= link_to "Prepare Cookie", new_oven_cookies_path(@oven), class: 'button' %>
</div>

app/views/store/index.html.erb
<h3>Your Bakery</h3>
<div class="bakery-nav">
  <%= link_to "View your ovens", ovens_path %>
</div>
<br>

<div class="store-inventory">
  Cookies for sale:
  <ul>
    <% @cookies.each_pair do |fillings, quantity| %>
      <li><%= pluralize(quantity, "Cookie") %> with <%= fillings || "no filling" %></li>
    <% end %>
  </ul>
</div>

app/views/visitors/index.html.erb
<h3>Welcome to the Flowspace Bakery</h3>